badEnd = room {
	nam = 'Миссия провалена.',
	dsc = 'Игра закончена.',
	
};

bankLeft = room {
	nam = function()
		if here() == bankLeft then
			return 'Берег Левый';
		end;
		return 'Плыть на левый берег.';
	end,
	
	dsc = 'Это левый берег реки.',
	way = { 'bankRight' },
	enter = function(s, f)
		if f == bankRight then
			checkBadEnd(s);
		end;
	end,
	
	exit = function(s, f)
		if f == bankLeft or f == bankRight then
			put(boat, f);
			remove(boat, s);
		end;
	end
};

bankRight = room {
	nam = function()
		if here() == bankRight then
			return 'Берег Правый';
		end;
		return 'Плыть на правый берег.';
	end,
	
	dsc = 'Это правый берег реки.',
	way = { 'bankLeft' },
	enter = function(s, f)
		checkBadEnd(s);
	end,
	
	exit = function(s, f)
		if f == bankLeft or f == bankRight then
			put(boat, f);
			remove(boat, s);
		end;
	end
};

goodEnd = room {
	nam = 'Миссия выполнена.',
	dsc = 'Поздравляем! Вы успешно закончили игру.',
	
};

boat = obj {
	nam = 'Лодка',
	dsc = 'У берега стоит маленькая лодочка.',
	
};

goat = obj {
	nam = 'Коза',
	dsc = 'Рядом стоит {коза} и смотрит вдаль. На {козу} одет ошейник, к ошейнику привязана веревочка.',
	
	act = function(s)
		if #boat.obj == 0 then
			objs():del('goat');
			boat.obj:add('goatOnBoat');
			p 'Вы заводите козу в лодку.';
		else
			p 'Вы не можете посадить в лодку более одного пассажира.'
		end
	end
	
};

goatOnBoat = obj {
	nam = 'Коза',
	dsc = 'В лодке стоит {коза} и смотрит вдаль.',
	
	act = function(s)
		boat.obj:del('goatOnBoat');
		objs():add('goat');
		p 'Вы выводите козу на берег.';
		checkGoodEnd();
	end
	
};

kapusta = obj {
	nam = 'Капуста',
	dsc = 'На земле лежит большой кочан {капусты}.',
	
	act = function(s)
		if #boat.obj == 0 then
			objs():del('kapusta');
			boat.obj:add('kapustaOnBoat');
			p 'Вы кладете капусту в лодку.';
		else
			p 'Вы не можете посадить в лодку более обного пассажира.'
		end
	end
	
};

kapustaOnBoat = obj {
	nam = 'Капуста',
	dsc = 'В лодке лежит большой кочан {капусты}.',
	act = function(s)
		p 'Вы кладете капусту на землю.';
		boat.obj:del('kapustaOnBoat');
		objs():add('kapusta');
		checkGoodEnd();
	end
	
};

wolf = obj {
	nam = 'Волк',
	dsc = 'Прирученый {волк} сидит недалеко от вас.',
	
	act = function(s)
		if #boat.obj == 0 then
			objs():del('wolf');
			boat.obj:add('wolfOnBoat');
			p 'Вы садите волка в лодку.';
		else
			p 'Вы не можете посадить в лодку более обного пассажира.'
		end
	end
	
};

wolfOnBoat = obj {
	nam = 'Волк',
	dsc = 'Прирученый {волк} сидит в лодке.',
	
	act = function(s)
		p 'Вы выводите волка на берег.';
		boat.obj:del('wolfOnBoat');
		objs():add('wolf');
		checkGoodEnd();
	end
};

